#include "fbsd-compat.h"

#include "cx25840.h" /* waar is dat voor nodig ?? */

#include "dev/iicbus/iiconf.h"

int i2c_last_delay=1000;
u8 i2c_cl[4];
void *i2c_cd;

void cx25840_i2c_set_delay(device_t client, int delay)
{
        i2c_last_delay = 1000;
}
/*
void * i2c_get_clientdata(device_t client)
{
        return i2c_cd;
}
*/

int i2c_master_send(device_t client, u8 *buffer, int len)
{
        int sent;
	int res;
        /*res= iicbus_write(client, buffer, len, &sent,i2c_last_delay) ;  */
#ifndef _tuinkabouter_
 u_char addr = i2c_cl[device_get_unit(client)] & ~0x1;
        int error;

        if ((error = iicbus_start(client, addr, 10000)))
{
int i;
printf("could not start iic bus \n");
for(i=2;i<256;i+=2)
{
if(!iicbus_start(client,i,0))
{
printf("probed %d\n",i);
iicbus_stop(client);
}
}

                return (error);
}

        res = iicbus_write(client, buffer, len, &sent, 10000);

        iicbus_stop(client);
#else


res=iicbus_block_write(client, i2c_cl[device_get_unit(client)], buffer, len, &sent); 
#endif
	if(res!=0)
        {
		u8 n;
		n = i2c_cl[device_get_unit(client)];
		printf("send error @ %d\n",(int)n);
	}

	if(sent>0)
		return sent;
	else
		return -1;
}

int i2c_master_recv(device_t client, u8 *buffer, int len)
{
        int received;
	int res;
	/*
        iicbus_read(client,  buffer, len, &received,IIC_LAST_READ,0) ; */
	res= iicbus_block_read(client, i2c_cl[device_get_unit(client)], buffer,len, &received );
	if(res!=0)
		printf("read error\n");
        return received;
}

#include "cx25840_fw.h"

int request_firmware(void **fw, char *file, int dummy)
{
        static struct firmware thef;

	*fw = &thef;
        thef.data=cx25840_fw;
        thef.size = 14264;

        return 0;
}

int release_firmware(void *fw )
{
        return 0;
}


